//
//  UAPI.h
//  usctp
//
//  Created by Andreas Fink on 17.10.20.
//  Copyright © 2020 Andreas Fink. All rights reserved.
//

#include <stdint.h>
#include <sys/types.h>

#include "UData.h"
#include "UTcp_Socket.h"


typedef struct UAPI
{
    uint32_t function;
    uint32_t txseq;
    uint32_t rxseq;
    uint32_t reqid;
    uint32_t err;
    uint32_t flags;
    uint32_t stream;
    uint32_t assoc;
    uint32_t len;
    uint32_t a;
    uint32_t b;
    uint32_t c;
} UAPI;

#define UAPI_BEAT       0x00000000
#define UAPI_BEAT_ACK   0x80000000

#define UAPI_HELLO_REQ  0x00000001
#define UAPI_HELLO_RESP 0x80000001

#define UAPI_AUTH_REQ   0x00000002
#define UAPI_AUTH_RESP  0x80000002

ssize_t uapi_write_to_socket(UTcp_Socket *s, UAPI *api, UData *data);
ssize_t uapi_read_from_socket(UTcp_Socket *s, UAPI *api, UData **data);

