//
//  UAPI_Connection.h
//  usctp
//
//  Created by Andreas Fink on 17.10.20.
//  Copyright © 2020 Andreas Fink. All rights reserved.
//

#if !defined(UAPI_CONNECTION_H)
#define UAPI_CONNECTION_H 1
#include "UList.h"
#include "UThread.h"
#include "UTcp_Socket.h"
#include "UAPI_Handler.h"

typedef struct UAPI_Connection
{
    UThread                 _ut;
    UTcp_Socket             *_isock;
    int                     _lastError;
    UAPI_Handler            *_handler;
    uint32_t                last_txseq;
    uint32_t                last_rxseq;
    uint32_t                windowSize;
} UAPI_Connection;

UAPI_Connection *uapi_connection_alloc(void);
UAPI_Connection *uapi_connection_init_with_socket(UAPI_Connection *u,UTcp_Socket *sock);
int uapi_connection_start(UAPI_Connection *u, void *data);
int uapi_connection_stop(UAPI_Connection *u, void *data);
int uapi_connection_run(UThread *u, void *data);
void uapi_connection_set_handler(UAPI_Connection *u, UAPI_Handler *h);


uint32_t    uapi_connection_next_txseq(UAPI_Connection *u);
void    uapi_connection_set_rxseq(UAPI_Connection *u, uint32_t rxseq);
uint32_t    uapi_connection_get_rxseq(UAPI_Connection *u);

#endif /* UAPI_CONNECTION_H */
