//
//  UAPI_Handler.h
//  usctp
//
//  Created by Andreas Fink on 17.10.20.
//  Copyright © 2020 Andreas Fink. All rights reserved.
//


#if !defined(UAPI_HANDLER_H)
#define UAPI_HANDLER_H 1

#include "UData.h"
struct UAPI;
struct UTcp_Socket;
struct UAPI_Handler;

typedef int (*UAPI_Handler_Func)(struct UAPI_Handler *u, struct UTcp_Socket *socket,struct UAPI *api, UData *data);

typedef struct UAPI_Handler
{
    UObject                 _u;
    UAPI_Handler_Func       _call;
} UAPI_Handler;

UAPI_Handler *uapi_handler_alloc(void);
UAPI_Handler *uapi_handler_init(UAPI_Handler *u);
int uapi_handler_call(UAPI_Handler *u, struct UTcp_Socket *socket,struct UAPI *api, UData *data);
int uapi_default_handler(UAPI_Handler *u, struct UTcp_Socket *socket,struct UAPI *api, UData *data);


#endif /* UAPI_HANDLER_H */
