//
//  USctp_ApiListener.h
//  usctp
//
//  Created by Andreas Fink on 14.10.20.
//  Copyright © 2020 Andreas Fink. All rights reserved.
//





#if !defined(UAPI_LISTENER_H)
#define UAPI_LISTENER_H 1
#include "UList.h"
#include "UThread.h"
#include "UTcp_Socket.h"
#include "UAPI_Handler.h"

typedef struct UAPI_Listener
{
    UThread                 _ut;
    UIP_Address             *_localAddress;
    int                     _port;
    UTcp_Socket             *_listenerSocket;
    int                     _lastError;
    UAPI_Handler            *_handler;
} UAPI_Listener;

UAPI_Listener *uapi_listener_alloc(void);
UAPI_Listener *uapi_listener_init_with_port(UAPI_Listener *u,int port);

int uapi_listener_start(UAPI_Listener *u, void *data);
int uapi_listener_stop(UAPI_Listener *u, void *data);
int uapi_listener_run(UThread *u, void *data);
void uapi_listener_set_handler(UAPI_Listener *u, UAPI_Handler *handler);

#endif /* UAPI_LISTENER_H */
