//
//  UIP_Address.h
//  usctp
//
//  Created by Andreas Fink on 12.10.20.
//  Copyright © 2020 Andreas Fink. All rights reserved.
//

#ifndef UIP_ADDRESS_H
#define UIP_ADDRESS_H 1

#import "UObject.h"
#import "UData.h"

typedef struct UIP_Address
{
    UObject         _u;
    int             _version;
    union
    {
        struct sockaddr     generic;
        struct sockaddr_in  ipv4;
        struct sockaddr_in6 ipv6;
    } address;
} UIP_Address;


UIP_Address *uip_address_alloc(void);
UIP_Address *uip_address_init(UIP_Address *u);
UIP_Address *uip_address_copy(UIP_Address *u);


int uip_address_list_match(UObject *o, void *private_data); /* function should return -1 to continue interating or something else to end */
int uip_address_and_port_list_match(UObject *o, void *private_data);

int uip_address_compare(UIP_Address *a,UIP_Address *b); /* returns 0 if equal -1 if descending order 1 if ascending order */
int uip_address_and_port_compare(UIP_Address *a,UIP_Address *b); /* returns 0 if equal -1 if descending order 1 if ascending order */

UIP_Address *uip_address_init_with_any6(UIP_Address *u);
UIP_Address *uip_address_init_with_any4(UIP_Address *u);
UIP_Address *uip_address_init_with_any(UIP_Address *u);
UData *uip_address_as_string(UIP_Address *u);

#endif /* UIP_ADDRESS_H */
