//
//  UMutex.h
//  usctp
//
//  Created by Andreas Fink on 10.10.2020
//  Copyright © 2019 Andreas Fink. All rights reserved.
//

/* umutex
 *
 * a mutex. one of the few c-objects not derived from uclass as uclass uses it
 *
 */

#if !defined(UMUTEX_H)
#define UMUTEX_H

#include <pthread.h>

typedef struct UMutex
{
    pthread_mutex_t     mutexLock;
    pthread_mutexattr_t mutexAttr;
} UMutex;

UMutex *umutex_init(UMutex *mutex);
void umutex_exit(UMutex *mutex);
void umutex_lock(UMutex *mutex);
void umutex_unlock(UMutex *mutex);
int umutex_trylock(UMutex *mutex); /* returns 0 if successful */

#endif /* UMUTEX_H */

