//
//  USctp_ApiInstance.h
//  usctp_api
//
//  Created by Andreas Fink on 14.10.20.
//  Copyright © 2020 Andreas Fink. All rights reserved.
//


#if !defined(USCTP_API_INSTANCE_H)
#define USCTP_API_INSTANCE_H 1

#include "UObject.h"
#include "UList.h"
#include "UData.h"
#include "USctp_ApiSocket.h"

typedef struct USctp_ApiInstance
{
    UObject         _u;
    UList           *_apiSockets;
    int             _last_socket_id;
} USctp_ApiInstance;

USctp_ApiInstance *usctp_apiinstance_alloc(void);
USctp_ApiInstance *usctp_apiinstance_init(USctp_ApiInstance *u);
USctp_ApiSocket *usctp_apiinstance_get_apisocket(USctp_ApiInstance *u, int sockid);
int usctp_apiinstance_add_apisocket(USctp_ApiInstance *u, USctp_ApiSocket *s); /* returns new socket identifier */
void usctp_apiinstance_remove_apisocket(USctp_ApiInstance *u,USctp_ApiSocket *apisocket);

struct USctp_ApiHandler;
struct UTcp_Socket;
struct UAPI;

int usctp_apiinstance_incoming_noop(USctp_ApiInstance *u,struct USctp_ApiHandler *h, struct UTcp_Socket *socket,struct UAPI *api, UData *data);
int usctp_apiinstance_incoming_socket_request(USctp_ApiInstance *u,struct USctp_ApiHandler *h, struct UTcp_Socket *socket,struct UAPI *api, UData *data);
int usctp_apiinstance_incoming_socket_response(USctp_ApiInstance *u,struct USctp_ApiHandler *h, struct UTcp_Socket *socket,struct UAPI *api, UData *data);
int usctp_apiinstance_incoming_bindx_request(USctp_ApiInstance *u,struct USctp_ApiHandler *h, struct UTcp_Socket *socket,struct UAPI *api, UData *data);
int usctp_apiinstance_incoming_bindx_response(USctp_ApiInstance *u,struct USctp_ApiHandler *h, struct UTcp_Socket *socket,struct UAPI *api, UData *data);
int usctp_apiinstance_incoming_listen_request(USctp_ApiInstance *u,struct USctp_ApiHandler *h, struct UTcp_Socket *socket,struct UAPI *api, UData *data);
int usctp_apiinstance_incoming_listen_response(USctp_ApiInstance *u,struct USctp_ApiHandler *h, struct UTcp_Socket *socket,struct UAPI *api, UData *data);
int usctp_apiinstance_incoming_accept_request(USctp_ApiInstance *u,struct USctp_ApiHandler *h, struct UTcp_Socket *socket,struct UAPI *api, UData *data);
int usctp_apiinstance_incoming_accept_response(USctp_ApiInstance *u,struct USctp_ApiHandler *h, struct UTcp_Socket *socket,struct UAPI *api, UData *data);
int usctp_apiinstance_incoming_connectx_request(USctp_ApiInstance *u,struct USctp_ApiHandler *h, struct UTcp_Socket *socket,struct UAPI *api, UData *data);
int usctp_apiinstance_incoming_connectx_response(USctp_ApiInstance *u,struct USctp_ApiHandler *h, struct UTcp_Socket *socket,struct UAPI *api, UData *data);
int usctp_apiinstance_incoming_write_request(USctp_ApiInstance *u,struct USctp_ApiHandler *h, struct UTcp_Socket *socket,struct UAPI *api, UData *data);
int usctp_apiinstance_incoming_write_response(USctp_ApiInstance *u,struct USctp_ApiHandler *h, struct UTcp_Socket *socket,struct UAPI *api, UData *data);
int usctp_apiinstance_incoming_read_request(USctp_ApiInstance *u,struct USctp_ApiHandler *h, struct UTcp_Socket *socket,struct UAPI *api, UData *data);
int usctp_apiinstance_incoming_read_response(USctp_ApiInstance *u,struct USctp_ApiHandler *h, struct UTcp_Socket *socket,struct UAPI *api, UData *data);



#endif /* USCTP_API_SOCKET_H */
