//
//  USctp_Assoc.h
//  usctp
//
//  Created by Andreas Fink on 12.10.20.
//  Copyright © 2020 Andreas Fink. All rights reserved.
//

#if !defined(USCTP_ASSOC_H)
#define USCTP_ASSOC_H 1

#include "USctp_Types.h"
#include "UPacket.h"
#include "UList.h"
#include "USctpState.h"
#include "UTimer.h"

struct USctp_Instance;

typedef struct USctp_Assoc
{
    UObject         _u;
    UList           *_remote_ips;
    UList           *_local_ips;
    struct USctp_Instance     *_sctp;
    USctpState      _state;
    UTimer          *_t1_init_timer;
    UTimer          *_t2_shutdown_timer;
    UTimer          *_t3_retransmission_timer;
    int             _max_init_retransmits;

} USctp_Assoc;

USctp_Assoc *usctp_assoc_alloc(void);
USctp_Assoc *usctp_assoc_init(USctp_Assoc *u);

void usctp_assoc_add_local_ip(USctp_Assoc *u,UIP_Address *ip);
void usctp_assoc_add_remote_ip(USctp_Assoc *u,UIP_Address *ip);



int uscctp_assoc_match_remote_ip_and_port(USctp_Assoc *u,UIP_Address *ip);  /* returns -1 if not found, returns index into list */
int uscctp_assoc_match_local_ip_and_port(USctp_Assoc *u,UIP_Address *ip);   /* returns -1 if not found, returns index into list */
int uscctp_assoc_match_remote_ip(USctp_Assoc *u,UIP_Address *ip);           /* returns -1 if not found, returns index into list */
int uscctp_assoc_match_local_ip(USctp_Assoc *u,UIP_Address *ip);            /* returns -1 if not found, returns index into list */


#endif /* USCTP_H  */
