//
//  USctp_Chunk.h
//  usctp
//
//  Created by Andreas Fink on 13.10.20.
//  Copyright © 2020 Andreas Fink. All rights reserved.
//


#if !defined(USCTP_CHUNK_H)
#define USCTP_CHUNK_H 1

#include "USctp_Types.h"
#include "UPacket.h"
#include "UList.h"

struct USctp_Chunk;
typedef void (*usctp_chunk_encode_function_ptr)(struct USctp_Chunk *u);

typedef struct USctp_Chunk
{
    UObject         _u;
    int             _type;
    int             _flags;
    size_t          _length;
    UData           *_encodedData;
    UData           *_payload;
    UData           *_variableParametersEncoded;
    UList           *_variableParametersList;
    usctp_chunk_encode_function_ptr _encode_func;
    
} USctp_Chunk;

USctp_Chunk *usctp_chunk_alloc(void);
USctp_Chunk *usctp_chunk_init(USctp_Chunk *u);
void usctp_chunk_encode(USctp_Chunk *u);

#endif /* USCTP_CHUNK_H */
