//
//  USctp_Chunk_Parameter.h
//  usctp
//
//  Created by Andreas Fink on 13.10.20.
//  Copyright © 2020 Andreas Fink. All rights reserved.
//


#if !defined(USCTP_CHUNK_PARAMETER_H)
#define USCTP_CHUNK_PARAMETER_H 1

#include "USctp_Types.h"
#include "UPacket.h"
#include "UList.h"

struct USctp_Chunk;
typedef void (*usctp_chunk_encode_function_ptr)(struct USctp_Chunk *u);

typedef struct USctp_Chunk_Parameter
{
    UObject         _u;
    uint16_t        _type;
    UData           *_payload;
} USctp_Chunk_Parameter;

USctp_Chunk_Parameter *usctp_chunk_parameter_alloc(void);
USctp_Chunk_Parameter *usctp_chunk_parameter_init(USctp_Chunk_Parameter *u);
UData *usctp_chunk_parameter_encode(USctp_Chunk_Parameter *u); /* returns retained UData */
UData *usctp_chunk_parameters_encode_list(UList *u);           /* returns retained UData */

#endif /* USCTP_CHUNK_PARAMETER_H */
