//
//  UString.h
//  usctp
//
//  Created by Andreas Fink on 20.10.20.
//  Copyright © 2020 Andreas Fink. All rights reserved.
//

#if !defined(USTRING_H)
#define USTRING_H   1

#include "UObject.h"
#include "UData.h"


typedef struct UString
{
    UData       _ud;
} UString;

UString *ustring_alloc(void);
UString *ustring_init(UString *ud);
UString *ustring_init_with_cstring(UString *u,const char *cptr);
UString *ustring_init_with_bytes_len(UString *u,const char *bytes, ssize_t len);

UString *ustring_append_ustring(UString *u, UString *u2);
UString *ustring_append_string(UString *u, const char *str);
const char *ustring_cstring(UString *u);
size_t ustring_length(UString *u);


#endif /* USTRING_H */
