//
//  UTask.h
//  usctp
//
//  Created by Andreas Fink on 20.10.20.
//  Copyright © 2020 Andreas Fink. All rights reserved.
//


#if !defined(UTASK_H)
#define UTASK_H 1

#import "UObject.h"

struct UTask;
struct UTaskQueue;
struct UTaskRunner;

typedef  void   (*UTask_Function_Ptr)(struct UTaskRunner *tr, struct UTaskQueue *tq, struct UTask *t, UObject *o1, UObject *o2);
typedef struct UTask
{
    UObject             _u;
    UTask_Function_Ptr _executeFunc;
    UObject             *_executeParam1;
    UObject             *_executeParam2;
} UTask;

UTask *utask_alloc(void);
UTask *utask_init(UTask *u);
UTask *utask_init_with_function_and_params(UTask *u, UTask_Function_Ptr func, UObject *p1, UObject *p2);
void utask_execute(struct UTaskRunner *tr, struct UTaskQueue *tq, UTask *uo);


#endif /* UTASK_H */

