//
//  UTaskQueue.h
//  usctp
//
//  Created by Andreas Fink on 20.10.20.
//  Copyright © 2020 Andreas Fink. All rights reserved.
//


#if !defined(UTASKQUEUE)
#define UTASKQUEUE 1

#include "UList.h"
#include "UThread.h"
#include "UQueue.h"
struct UTask;

typedef struct UTaskQueue
{
    UObject                 _u;
    UQueue                  *_queue;
    UList                   *_taskRunners;
    int                     _mustRun;
} UTaskQueue;

UTaskQueue *utaskqueue_alloc(void);
UTaskQueue *utaskqueue_init_with_threadcount(UTaskQueue *u, int threadcount);

struct UTask *utaskqueue_get_next_retained(UTaskQueue *u);
void utaskqueue_append(UTaskQueue *u,struct UTask *task);

int utaskqueue_start(UTaskQueue *u, void *data);
int utaskqueue_stop(UTaskQueue *u, void *data);

int utaskqueue_must_run(UTaskQueue *u);

#endif /* UTASKQUEUE */
