//
//  UTaskRunner.h
//  usctp
//
//  Created by Andreas Fink on 20.10.20.
//  Copyright © 2020 Andreas Fink. All rights reserved.
//



#if !defined(UTASK_RUNNER)
#define UTASK_RUNNER 1
#include "UList.h"
#include "UThread.h"
#include "UTaskQueue.h"

typedef struct UTaskRunner
{
    UThread                 _ut;
    UTaskQueue              *_taskQueue;
    int                     _pipeTX;
    int                     _pipeRX;
    int                     _number;
} UTaskRunner;

UTaskRunner *utaskrunner_alloc(void);
UTaskRunner *utaskrunner_init_with_task_queue(UTaskRunner *u,UTaskQueue *queue);

int utaskrunner_start(UTaskRunner *u, void *data);
int utaskrunner_stop(UTaskRunner *u, void *data);
int utaskrunner_run(UThread *ut, void *data);int utaskrunner_run(UThread *ut, void *data);
int utaskrunner_do_wakeup(UTaskRunner *u);

#endif /* UTASK_RUNNER */
