//
//  UTimer.h
//  usctp
//
//  Created by Andreas Fink on 13.10.20.
//  Copyright © 2020 Andreas Fink. All rights reserved.
//


#ifndef UTIMER_H
#define UTIMER_H 1

#include "UObject.h"

typedef struct UTimer
{
    UObject         _u;
    int             _seconds;
    time_t          _start_time;
    time_t          _end_time;
    int             _is_running;
} UTimer;


UTimer *utimer_alloc(void);
UTimer *utimer_init(UTimer *u);

void utimer_start(UTimer *u);
void utimer_stop(UTimer *u);
void utimer_set(UTimer *u,int seconds);
int utimer_is_running(UTimer *u);
int utimer_is_expired(UTimer *u);

#endif /* UTIMER_H */
