//
//  nbo.h
//  usctp
//
//  Created by Andreas Fink on 12.10.20.
//  Copyright © 2020 Andreas Fink. All rights reserved.
//


#ifndef NBO_H
#define NBO_H 1
#include <stdint.h>
/* network byte order (NBO) integers */

#if !defined htonll
#include <endian.h>
#define htonll(a) htobe64(a)
#define ntohll(a) be64toh(a)
#endif

typedef uint8_t         nbo_uint8_t;
typedef uint16_t        nbo_uint16_t;
typedef uint32_t        nbo_uint32_t;
typedef uint64_t        nbo_uint64_t;

#define SET_NBO_UINT8(a)    (a)
#define GET_NBO_UINT8(a)    (a)

#define SET_NBO_UINT16(a)   (htons(a))
#define GET_NBO_UINT16(a)   (ntohs(a))

#define SET_NBO_UINT32(a)   (htonl(a))
#define GET_NBO_UINT32(a)   (ntohl(a))

#define SET_NBO_UINT64(a)   (htonll(a))
#define GET_NBO_UINT64(a)   (ntohll(a))


#endif

