//
//  usctp_ethernet_handler.h
//  usctp
//
//  Created by Andreas Fink on 13.11.19.
//  Copyright © 2019 Andreas Fink. All rights reserved.
//

#if !defined(USCTP_ETHERNET_HANDLER_H)
#define USCTP_ETHERNET_HANDLER_H 1

#include "USctp_Types.h"
#include <net/ethernet.h>
#include "UList.h"
#include "usctp_ip_handler.h"

struct usctp_packet;

typedef struct usctp_ethernet_handler
{
    UObject                 _u;
    UList                   *_src_ethernet_addresses;
    UList                   *_dst_ethernet_addresses;
    usctp_ip_handler        *_ip_handler;
    int                     _src_ethernet_any;
    int                     _dst_ethernet_any;

} usctp_ethernet_handler;

usctp_ethernet_handler *usctp_ethernet_handler_alloc(void);
usctp_ethernet_handler *usctp_ethernet_handler_init(usctp_ethernet_handler *e);

struct usctp_packet *usctp_ethernet_handler_process_incoming_frame(usctp_ethernet_handler *e,const uint8_t *ptr, size_t len);

#endif /* USCTP_ETHERNET_HANDLER_H */
