//
//  usctp_packet.h
//  usctp
//
//  Created by Andreas Fink on 18.11.19.
//  Copyright © 2019 Andreas Fink. All rights reserved.
//

#include "UObject.h"
#include "UList.h"
#include "UData.h"

#include <net/ethernet.h>


#include "USctp_Types.h"
#include <net/ethernet.h>
#include "usctp_ethernet_address.h"
#include "usctp_ip_address.h"

typedef struct usctp_packet
{
    UObject                 _u;
    UData                   *_ethernet_frame;
    usctp_ethernet_address  *_ether_source;
    usctp_ethernet_address  *_ether_destination;
    UData                   *_ip_frame;
    usctp_ip_address        *_ip_source;
    usctp_ip_address        *_ip_destination;
    int                     _protocol;
    int                     _source_port;
    int                     _destination_port;
} usctp_packet;

usctp_packet *usctp_packet_alloc(void);
usctp_packet *usctp_packet_init(usctp_packet *e);

